#lang racket

;;;; 8. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 12.4.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - metainterpreter programovacieho jazyka LISP.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 5
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 17.4.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)
;; (define apply-in-underlying-scheme apply)
(require scheme/mpair)

;;; Kapitola. Metainterpreter programovacieho jazyka LISP.

;;; Sekcia. Vyhodnocovanie výrazov v prostredí väzieb.

;;; Podsekcia. Aritmetizácia.

;; Rozlišovacie položky zoznamových konštruktorov.

(define (tagged-list? exp tag)
  (and (pair? exp)
       (equal? (car exp) tag)))

;; Aritmetizácia výrazov (schéma). 

(define (make-<variant> ...) (list '<variant> ...))     ; konštruktor
(define (<variant>? exp) (tagged-list? exp '<variant>)) ; predikát
(define (<variant>-<selector> exp) ...)                 ; selektor(y)
(define (eval-<variant> exp env) ...)                   ; vyhodnocovanie

;;; Podsekcia. Vyhodnocovanie výrazov v prostredí väzieb.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

;; Operácia my-eval(exp,env) vyhodnotí výraz exp v prostredí väzieb env.

(define (my-eval exp env)
  (cond [(<variant>? exp) (eval-<variant> exp env)]
        [else (error "Unknown expression type -- EVAL" exp)]))

;;; Podsekcia. Operácie nad prostredím väzieb.

;; Základné operácie.

(define the-empty-environment '())
(define (empty-environment? env) (null? env))
(define (enclosing-environment env) (mcdr env))
(define (first-frame env) (mcar env))
(define the-empty-frame '())
(define (binding-value binding) (mcdr binding))

;; Modifikácia prostredia väzieb.

(define (set-first-frame! env frame) (set-mcar! env frame))
(define (set-binding-value! binding val) (set-mcdr! binding val))

;; Rozšírenie prostredia väzieb.

(define (make-environment frame env)
  (mcons frame env))

(define (add-to-frame-let binding frame)
  (mcons (mcons (car binding) (cadr binding)) frame))

(define (add-to-frame-apply var val frame)
  (mcons (mcons var val) frame))

(define (extend-environment-let bindings env)
  (define (loop bindings frame)
    (if (null? bindings)
        (make-environment frame env)
        (loop (cdr bindings) (add-to-frame-let (car bindings) frame))))
  (loop bindings the-empty-frame))

(define (extend-environment-apply vars vals env)
  (define (loop vars vals frame)
    (if (and (null? vars) (null? vals))
        (make-environment frame env)
        (loop (cdr vars) (cdr vals) (add-to-frame-apply (car vars) (car vals) frame))))
  (loop vars vals the-empty-frame))

;; Globálne prostredie väzieb.

(define (make-primitive-procedure proc)
  (list (string->symbol "primitive procedure") proc))

(define frame-of-primitive-procedures
  (mlist
   (mcons 'zero? (make-primitive-procedure zero?))
   (mcons '+ (make-primitive-procedure +))
   (mcons '- (make-primitive-procedure -))
   (mcons '* (make-primitive-procedure *))
   (mcons 'quotient (make-primitive-procedure quotient))
   (mcons 'remainder (make-primitive-procedure remainder))
   (mcons '= (make-primitive-procedure =))
   (mcons '<= (make-primitive-procedure <=))
   (mcons '< (make-primitive-procedure <))
   (mcons '>= (make-primitive-procedure >=))
   (mcons '> (make-primitive-procedure >))
   (mcons '... (make-primitive-procedure undefined))
   (mcons '#t (make-primitive-procedure #t))
   (mcons '#f (make-primitive-procedure #f))
   ))

(define the-global-environment
  (make-environment frame-of-primitive-procedures the-empty-environment))

;;; Podsekcia. Samo vyhodnocujúce sa výrazy.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Premenné.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma if (podmienkové výrazy).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma let (priradenie do lokálnej premennej).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma define (definície).

;; Konštruktor.
;; Syntax: <head> = <var> | (<var> <parameter₁> ... <parameterₙ>)

(define (make-definition head body) (list 'define head body))

;; Predikát.

(define (definition? exp) ...)

;; Selektor(y).

(define (definition-variable exp) ...)
(define (definition-value exp) ...)

;; Vyhodnocovanie.

(define (define-variable! var val env) ...)
(define (eval-definition exp env) ...)

;;; Podsekcia. Špeciálna forma lambda (operátor abstrakcie).

;; Konštruktor.

(define (make-lambda parameters body) (list 'lambda parameters body))

;; Predikát.

(define (lambda? exp) ...)

;; Selektor(y).

(define (lambda-parameters exp) ...)
(define (lambda-body exp) ...)

;; Vyhodnocovanie.

(define (eval-lambda exp env) ...)

;;; Podsekcia. Aplikatívne výrazy.

;;; Podsekcia. Programy.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

;; Konštruktor.

;; (define (make-primitive-procedure proc)
;;  (list (string->symbol "primitive procedure") proc))

(define (make-compound-procedure parameters body env)
  (list (string->symbol "compound procedure") parameters body env))

;; Predikát.

(define (primitive-procedure? proc) ...)
(define (compound-procedure? proc) ...)

;; Selektor(y).

(define (primitive-procedure-implementation proc) ...)

(define (compound-procedure-parameters proc) ...)
(define (compound-procedure-body proc) ...)
(define (compound-procedure-environment proc) ...)

;; Vyhodnocovanie.

(define (apply-primitive-procedure proc args) ...)
(define (apply-compound-procedure proc args) ...)
(define (my-apply proc args) ...)

;;; Podsekcia. "Read–eval–print loop."

(define (my-read)
  (display "input : ")
  (read))

(define (my-print exp)
  (display "output: ")
  (if (compound-procedure? exp)
      (display '\#<procedure>)
      (display exp))
  (newline))

(define (driver-loop)
  (my-print (my-eval (my-read) the-global-environment))
  (driver-loop))

;; Ak chceme používať REPL, tak nasledujúci riadok treba odkomentovať.
;; (driver-loop)

;;; Podsekcia. Testovanie.

;; Táto časť slúži výlučne na testovanie. Nehodnotí sa!

;; Úloha. Zostrojte program, ktorý pre dané číslo vráti jeho druhú mocninu.

;; (my-eval '... the-global-environment)

;; (my-eval '(square 5) the-global-environment)

;; Úloha. Zostrojte program, ktorý pre dané dve čísla vypočíta súčet ich
;; štvorcov. 

;; (my-eval '... the-global-environment)

;; (my-eval '(sum-of-squares 3 4) the-global-environment)

;; Úloha. Zostrojte program, ktorý pre dané dve čísla vráti ich minimum.

;; (my-eval '... the-global-environment)

;; (my-eval '(min 1 2) the-global-environment)

;; Úloha. Definujte primitívnou rekurziou sumačnú funkciu.

;; (my-eval '... the-global-environment)

;; (my-eval '(sum 100) the-global-environment)

;; Úloha. Definujte primitívnou rekurziou funkciu faktoriál.

;; (my-eval '... the-global-environment)

;; (my-eval '(fact 6) the-global-environment)

;; Úloha. Implementujte Euklidov algoritmus pre výpočet najväčšieho spoločného
;; deliteľa dvoch prirodzených čísel.

;; (my-eval '... the-global-environment)

;; (my-eval '(gcd 21 12) the-global-environment)

;; Úloha. Nájdite iteratívny algoritmus pre výpočet Fibonacciho postupnosti.

;; (my-eval '... the-global-environment)

;; (my-eval '(fib 10) the-global-environment)
